<?php
/**
* Find pre tags with long lines and break them using the &raquo; char.
* @param string $argv[1] The file being processed
*/
$source = $argv[1];
$wrap = 78; 
$d = new DOMDocument();
$d->load($source);
$xp = new DOMXPath($d);
$ns = $d->documentElement->namespaceURI;
if ($ns) {
  $xp->registerNamespace("ns", $ns);
  $elements = $xp->query('//ns:pre');
} else {
  $elements = $xp->query('//pre');
}
for ($i = 0; $i < $elements->length; $i++) {
  $element = $elements->item($i);
  $content =  $element->textContent;
  $newcontent = truncate($content, $wrap);
  if ($newcontent != "") { //assign data to text node
    $element->replaceChild(new DOMText($newcontent), 
      $element->firstChild);
  }
}
$d->save($source);
/**
* Wrap lines at $wrap chars
* @param string  $all  The entire text node
* @param integer $wrap The character count where lines should wrap
* @return string The text node with new line breaks if needed
*/
function truncate($all, $wrap){
  $array = explode("\n", $all); 
  $contents = "";
  foreach ($array as $val){
    if (strlen($val) > $wrap) {
      $val = wordwrap($val, $wrap, "»\n", true); 
    }
    $val .= "\n";
    $contents .= $val;
  }
  $contents = trim($contents, "\n");
  return $contents;
}
?>