<?php
/**
* Set a document name at runtime by assigning
* a value to a variable.
* @param $argv[1] string The .flvar file name
* @param $argv[2] string The value for the document name
*/
if ($argc != 3){
  echo "Incorrect number of parameters.";
  exit(1);
}
$source = $argv[1]; 
$value = $argv[2]; 
$doc = new DOMDocument();
$doc->load($source);
$xpath = new DOMXPath($doc);
//find variable
$nodes = $xpath->query("//Variable[@Name='title']"); 
//create text node
$text = $doc->createTextNode($value);
//there should only be one variable with this name
$nodes->item(0)->appendChild($text); 
$doc->save($source);
?>