<?php
/**
* Set style for <ol> with type attribute.
* (Only inline styles work for PDFs.)
* © 2017 Moneris Solutions Corporation, CC-BY-NC -SA 4.0
*/
error_reporting(E_ERROR); 
//find all HTML files in the current directory
foreach (glob("./*.{xhtml,html,htm}", GLOB_BRACE) as $file){
  $changed = false;
  $d = new DOMDocument();
  $d->load($file);
  $xpath = new DOMXPath($d);
  $ns = $d->documentElement->namespaceURI;
  if($ns) {
    $xpath->registerNamespace("ns", $ns);
    $query = "//ns:ol[@type and not(@style)]"; 
  } else {
    $query = "//ol[@type and not(@style)]";
  } 
  $elements = $xpath->query($query);
  if($elements->item(0)){ 
    foreach ($elements as $node) {
      $style = "";
      $type = $node->getAttribute("type");
      switch ($type) {
        case "a":
          $style = "lower-alpha";
          break;
        case "A":
          $style = "upper-alpha";
          break;
        case "i":
          $style = "lower-roman";
          break;
        case "I":
          $style = "upper-roman";
          break;
        default:
      }
      if($style != ""){
        $node->setAttribute("style", "list-style-type: " . $style . ";" ); 
        $changed = true;
      }
    }
  }
  if ($changed){
    echo "Saved $file.";
    $d->save($file);
  }
}
?>