<?php
/**
* Remove style links from the head of every page in the current directory.
* <link rel="stylesheet" type="text/css" ... /> or
* <script type="text/javascript" ... />
* @param string $argv[1] Pass either "js" or "css"
*/
$type = $argv[1]; 
if ($type == "js"){
  $query = "script[@type='text/javascript']"; 
} elseif ($type == "css"){
  $query = "link[@rel='stylesheet'][@type='text/css']";
} else {
  echo "Pass \"js\" or \"css\"\n";
  exit(1);
}
//find all HTML files in the current directory
foreach (glob("./*.{xhtml,html,htm}", GLOB_BRACE) as $file){
  $d = new DOMDocument();
  $d->load($file);
  $xpath = new DOMXPath($d);
  $ns = $d->documentElement->namespaceURI;
  if($ns) {
    $xpath->registerNamespace("ns", $ns);
    $q = "//ns:head/ns:" . $query; 
  } else {
    $q = "//head/" . $query;
  }
  $elements = $xpath->query($q);
  if($elements->item(0)){
    foreach ($elements as $node) {
      $parent = $node->parentNode;
      $parent->removeChild($node); 
    }
  }
  $d->save($file);
}
?>