<?php
/**
* Create a name attribute for any anchor that has an id but
* does not have a name.
* Anchors with ids that do not have hrefs are destination anchors.
* This script creates a Flare bookmark for use with a Flare xref.
*/
//find all HTML files in the current directory
foreach (glob("./*.{xhtml,html,htm}", GLOB_BRACE) as $file){ 
  $d = new DOMDocument();
  $d->load($file);
  $xpath = new DOMXPath($d);
  //get namespace
  $ns = $d->documentElement->namespaceURI;
  if($ns) {
    $xpath->registerNamespace("ns", $ns);
    $elements = $xpath->query("//ns:a[@id and not(@name)]"); 
  } else {
    $elements = $xpath->query("//a[@id and not(@name)]");
  }
  if($elements->item(0)){
    foreach ($elements as $node) {
      $node->setAttribute("name", $node->getAttribute("id")); 
      $d->save($file);
    }
  }
}
?>