<?php
/**
* Search for all href links and extract the URLs
* for all files in the current directory.
* Output file is _urls.html
* © 2017 Moneris Solutions Corporation, CC-BY-NC -SA 4.0
*/
//fix line number bug
define('XML_PARSE_BIG_LINES', 4194304);
error_reporting(E_ERROR); 
$dest = "_urls.html";
$schemes = Array ("http", "https", "ftp", "mailto", "file", "javascript");
$s = " style=\"font-family: Courier;\"";
$contents = "<html><body $s><h1>Source Anchors</h1>";
//find all HTML files in the current directory
foreach (glob("./*.{xhtml,html,htm}", GLOB_BRACE) as $file){
  $d = new DOMDocument();
  // load file
  $d->load($file);
  $xp = new DOMXPath($d);
  $ns = $d->documentElement->namespaceURI;
  if ($ns){
    $xp->registerNamespace("ns", $ns);
    //find all anchors
    $nodelist = $xp->query('//ns:a[@href]');
  } else {
    $nodelist = $xp->query('//a[@href]'); 
  }
  //loop through list here
  if ($nodelist->item(0)){
    $message = "Extracting links from " . $file;
    $length = strlen($message);
    $contents .= "\n<br /><p>" . $message . "</p>\n";
    $contents .= "<p>" . str_repeat("-" , $length) . "</p>\n";
    foreach ($nodelist as $single){
      $href = $single->getAttribute('href');
      $scheme = parse_url($href, PHP_URL_SCHEME);
      $span = "<span>";
      if (!in_array($scheme, $schemes) && 
        trim($single->textContent) != "") {
        $span = "<span style=\"background-color: #ccccb3;\">";
      }
      $nt = "";
      if (trim($single->textContent) == ""){ 
        $nt = "(non-text)";
      }
	
      //check for internal reference and add page
      //so that it can be validated
      if (substr($href, 0, 1) == "#"){ 
        $href = $file . $href;
      }
      $contents .= "<p> line: " . $single->getLineNo() . " $nt ";
      $contents .= "$span <a href='" .  $href . "'>" .
        $href . "</a></span></p>\n";

    }
  }
}
$contents .="</body></html>";
file_put_contents($dest, $contents);
/*exec("firefox $dest");*/ 
?>